
#ifndef SPRITE_H
#define SPRITE_H


class masterScreen;


typedef unsigned char byte;

class RGB_Sprite
{
  public:

    void Sprite(byte width, byte height, ...);

    byte origin[2];
    byte width() const;
    byte height() const;
    void write(byte x, byte y, byte value);
    byte read(byte x, byte y) const;
    byte getSpriteValue(byte row, byte col);
    void printSprite();
    void updateOrigin(byte x, byte y);

    bool visible;
    bool isCollision(masterScreen screen_copy, byte new_x, byte new_y);
    bool isCollisionNoScreen(byte num_sprites, byte cur_index, RGB_Sprite Sprite_array[], byte new_x, byte new_y);
    bool isL_boardCollision();
    bool isR_boardCollision();
    bool isT_boardCollision();
    bool isB_boardCollision();
    unsigned long current_time;
    unsigned long previous_time;
    unsigned long duration;
    //x next, y next
    int x_;
    int y_;
    byte state;
    byte prevState;

  private:
    void init(byte width, byte height);

    byte _width;
    byte _height;
    byte ** _sprite;

};

#endif
// SPRITE_H
